/*
James Drury
ECET 380
04/27/2023
Self Irrigating Plant Fountain "S.I.P."
*/
#include <Servo.h>
Servo myservo;  // create servo object to control a servo
int potpin = A1;  // analog pin used to connect the potentiometer
int green = 2;    //LED Color Digital Pin Connections
int yellow = 3;
int red = 4;
int button = 5;   //Push button digital pin
int val;    // variable to read the value from the analog pin
void setup() {
  myservo.attach(9);  // attaches the servo on pin 9 to the servo object
  pinMode(green,OUTPUT);
  pinMode(yellow,OUTPUT);
  pinMode(red,OUTPUT);
  pinMode(button, INPUT_PULLUP);
  pinMode(A0,INPUT);
  //Serial.begin(9600);   //uncomment to read humidity values in serial monitor
}
void loop() {
  int humidity;
  humidity = analogRead(A0);
  humidity = map(humidity, 1023,300, 0, 100);
  delay(15);
  //Serial.println(humidity);   //uncomment to read humidity values in serial monitor
  int overide;  //overide button storage
  overide = digitalRead(button);    //store button press
  //myservo.write(100);
  if(60<humidity<80)    //plant will need watering soon
  {
    overide = digitalRead(button);    //yellow LED for intermediate mode
    digitalWrite(yellow,HIGH);
    digitalWrite(green,LOW);
    digitalWrite(red,LOW);
    myservo.write(0);
    if(!overide)
    {
      digitalWrite(red,HIGH);         //all LEDs on for overide mode
      digitalWrite(yellow,HIGH);
      digitalWrite(green,HIGH);
      overide = digitalRead(button);
      val = analogRead(potpin);            // reads the value of the potentiometer (value between 0 and 1023)
      val = map(val, 0, 1023, 0, 180);     // scale it for use with the servo (value between 0 and 180)
      myservo.write(val);                  // sets the servo position according to the scaled value
      delay(15);                           // waits for the servo to get there
    }
  }
  if(humidity<60)     //plant needs water
  {
    overide = digitalRead(button);      //red LED on for need water mode
    digitalWrite(yellow,LOW);
    digitalWrite(yellow,LOW);
    digitalWrite(red,HIGH);   
    myservo.write(45);    
    if(!overide)
    {
      digitalWrite(red,HIGH);           //all LEDs on for overide mode
      digitalWrite(yellow,HIGH);
      digitalWrite(green,HIGH);
      overide = digitalRead(button);
      val = analogRead(potpin);            // reads the value of the potentiometer (value between 0 and 1023)
      val = map(val, 0, 1023, 0, 180);     // scale it for use with the servo (value between 0 and 180)
      myservo.write(val);                  // sets the servo position according to the scaled value
      delay(15);                           // waits for the servo to get there
    }
  }
  if(humidity>80)     //plant is at ideal moisture level
  {
    overide = digitalRead(button);      //green LED on for proper levels mode
    digitalWrite(yellow,LOW);
    digitalWrite(green,HIGH);
    digitalWrite(red,LOW);
    myservo.write(0);
    if(!overide)
    {
      digitalWrite(red,HIGH);   //all LEDs on for overide mode
      digitalWrite(yellow,HIGH);
      digitalWrite(green,HIGH);
      overide = digitalRead(button);
      val = analogRead(potpin);            // reads the value of the potentiometer (value between 0 and 1023)
      val = map(val, 0, 1023, 0, 180);     // scale it for use with the servo (value between 0 and 180)
      myservo.write(val);                  // sets the servo position according to the scaled value
      delay(15);                           // waits for the servo to get there
    }
  }  
}
